package ;
	import org.cove.ape.APEngine;import org.cove.ape.AbstractCollection;import org.cove.ape.AbstractConstraint;import org.cove.ape.AbstractItem;import org.cove.ape.AbstractParticle;import org.cove.ape.CircleParticle;import org.cove.ape.Collision;import org.cove.ape.CollisionDetector;import org.cove.ape.CollisionResolver;import org.cove.ape.Composite;import org.cove.ape.Group;import org.cove.ape.Interval;import org.cove.ape.MathUtil;import org.cove.ape.RectangleParticle;import org.cove.ape.RimParticle;import org.cove.ape.SpringConstraint;import org.cove.ape.SpringConstraintParticle;import org.cove.ape.Vector;import org.cove.ape.WheelParticle;

	import neash.display.Sprite;
	import neash.events.Event;
	import neash.events.KeyboardEvent;
	//import neash.events.MouseEvent;

	/**
	 * untyped __is__(This,an) example showing use of the WheelParticles and collidable
	 * SpringConstraints cast(used,surfaces) in the 'bridge' area. The bouncy
	 * area has a high elasticity setting to push the car back up to the top.
	 */
	//[SWF(width="650", height="350", backgroundColor="#334433")]
	class CarDemo extends Sprite {
	static public function main() {
	neash.Lib.Init("CarDemo",650,350); 
	neash.Lib.SetBackgroundColour(0x000000); 
	new CarDemo(); 
	neash.Lib.Run(); 
	}


		private static var colA:Int = 0x334433;
		private static var colB:Int = 0x3366aa;
		private static var colC:Int = 0xaabbbb;
		private static var colD:Int = 0x6699aa;
		private static var colE:Int = 0x778877;

		private var car:Car;
		private var rotator:Rotator;
		private var mFPS:FPS;

		public function new() {
			neash.Lib.current.addChild(this);

			super();
			// set up the events, main loop handler, and the engine. you don't have to use
			// enterframe. you just need to call the ApeEngine.step() and ApeEngine.paint()
			// wherever and however you're handling your program cycle.
			stage.frameRate = 55;
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
                        stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
                        //stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);


			addEventListener(Event.ENTER_FRAME, run);

			// Initialize the engine. The argument untyped __is__(here,the) time step value.
			// Higher values scale the forces in the sim, making it appear to run
			// faster or slower. Lower values result in more accurate simulations.
			APEngine.init(1/4);

			// set up the default diplay container
			APEngine.container = this;

			// gravity -- particles of varying masses are affected the same
			APEngine.addMasslessForce(new Vector(0, 3));

			// groups - all these classes extend group
			var surfaces:Surfaces = new Surfaces(colA, colB, colC, colD, colE);
			APEngine.addGroup(surfaces);

			var bridge:Bridge = new Bridge(colB, colC, colD);
			APEngine.addGroup(bridge);

			var capsule:Capsule = new Capsule(colC);
			APEngine.addGroup(capsule);

			rotator = new Rotator(colB, colE);
			APEngine.addGroup(rotator);

			var swingDoor:SwingDoor = new SwingDoor(colC);
			APEngine.addGroup(swingDoor);

			car = new Car(colC, colE);
			APEngine.addGroup(car);

			// determine what collides with what.
			var car_list = new Array<Group>();
			car_list.push( surfaces);
			car_list.push( bridge);
			car_list.push( rotator);
			car_list.push( swingDoor);
			car_list.push( capsule );
			car.addCollidableList(car_list);

			var capsule_list = new Array<Group>();
			capsule_list.push( surfaces);
			capsule_list.push( bridge);
			capsule_list.push( rotator);
			capsule_list.push( swingDoor );
			capsule.addCollidableList(capsule_list);


                        mFPS = new FPS(10,10);
                        addChild(mFPS);
		}


		private function run(evt:Event):Void {
                        mFPS.BeginCalc();
			APEngine.step();
                        mFPS.EndCalc();
			APEngine.paint();
			rotator.rotateByRadian(.02);
		}


		//private function onMouseDown(evt:MouseEvent):Void {
			//APEngine.step();
			//APEngine.paint();
			//rotator.rotateByRadian(.02);
                //}

		private function keyDownHandler(keyEvt:KeyboardEvent):Void {

			var keySpeed:Float = 0.2;

			if (keyEvt.keyCode == 65) {
				car.speed = -keySpeed;
			} else if (keyEvt.keyCode == 68) {
				car.speed = keySpeed;
			}
		}


		private function keyUpHandler(keyEvt:KeyboardEvent):Void {
			car.speed = 0;
		}
	}

